#include <iostream>

//: C14:Car.cpp
// From Thinking in C++, 2nd Edition
// Available at http://www.BruceEckel.com
// (c) Bruce Eckel 2000
// Copyright notice in Copyright.txt
// Public composition
// modified by i.m. on 9 nov 2008
#include <string>


//        using namespace std;

class Vehicle {
        string type;
        public:
                Vehicle() { type = "car"; }
                Vehicle(string t) {
                        type = t;
                        std::cout << "Vehicle su type: " << type << std::endl;
                }
                ~Vehicle() { cout << "Vehicle destruct" << endl; }
                void setType(string x) { type = x; }
                void start() { cout << "Started" << endl; }

};


class Engine {
        string galia;
public:
        Engine(string g) {
                galia = g;
                cout << "Engine su galia: " << galia << endl;
        }
        ~Engine() { cout << "Engine destruct" << endl; }
  void start() const {}
  void rev() const {}
  void stop() const {}
};

class Wheels {
        string pavadinimas;
public:
        Wheels( string p) {
                        pavadinimas = p;
                        cout << "Wheels su pavadinimu: " << pavadinimas << endl;
        }
        ~Wheels() { cout << "Wheels destruct" << endl; }
  void inflate(int psi) const {}
};

class Window {
           string color;
public:
        Window(string c) {
                color = c;
                cout << "Window su spalva: " << color << endl;
        }
        ~Window() { cout << "Window destruct" << endl; }
  void rollup() const {}
  void rolldown() const {}
};

class Door {
        int number;
public:
        Door(int n, string win): window(win) {
                number = n;
                cout << "Door skaicius: " << number << endl;
        }
        ~Door() { cout << "Door destruct" << endl; }
  Window window;
  void open() const {}
  void close() const {}
};

class Car:public Vehicle {
        int ID;
public:
        Car(string t, int i, string g, string p, int d, string w): Vehicle(t), engine(g), 
wheels(p), left(d, w), right(2, "black")  {
                ID = i;
                cout << "Car su ID: " << ID << endl;
        }
        ~Car() { cout << "Car destruct" << endl; }
  Engine engine;
  Wheels wheels;
  Door left, right; // 2-door
};


int main() {
  Car car("car", 1, "2.0", "roller", 2, "white");
  car.left.window.rollup();
  car.wheels.inflate(72);
  car.start();

} ///:~
